#!/usr/bin/env node
"use strict";
/**
 * use-hoisted-version
 * Update lerna package to use hoisted version of npm dependency
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const t = __importStar(require("io-ts"));
const E = __importStar(require("fp-ts/Either"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("fp-ts/Record"));
const F = __importStar(require("fluture"));
const D = __importStar(require("io-ts-docopt"));
const PathReporter_1 = require("io-ts/lib/PathReporter");
const function_1 = require("fp-ts/function");
const io_ts_types_1 = require("io-ts-types");
const StringifiedJSON_1 = require("@typescript-tools/io-ts/dist/lib/StringifiedJSON");
const PackageJsonDependencies_1 = require("@typescript-tools/io-ts/dist/lib/PackageJsonDependencies");
const hoisted_packages_1 = require("@typescript-tools/hoisted-packages");
const lerna_utils_1 = require("@typescript-tools/lerna-utils");
const shades_1 = require("shades");
const find_up_1 = __importDefault(require("find-up"));
const debug_1 = __importDefault(require("debug"));
const fast_deep_equal_1 = __importDefault(require("fast-deep-equal"));
const ts_pattern_1 = require("ts-pattern");
const debug = {
    cmd: debug_1.default('hoist')
};
const docstring = `
Usage:
    use-hoisted-version <package>

Options:
    package    Package for which to update dependencies
`;
const CommandLineOptions = io_ts_types_1.withEncode(t.type({
    '<package>': t.string,
}), a => ({
    package: a['<package>']
}));
const decodeDocopt = function_1.flow(D.decodeDocopt, E.mapLeft((err) => ({ type: 'docopt decode', err: PathReporter_1.PathReporter.report(E.left(err)).join('\n') })));
const findup = function_1.flow(find_up_1.default.sync, O.fromNullable, O.map(path.dirname), E.fromOption(() => ({ type: 'package not in monorepo' })));
const updateDependencies = (packageJson) => (hoistedPackages) => {
    const withHoistedDependencies = (deps) => function_1.pipe(O.fromNullable(deps), O.map(R.reduceWithIndex({}, (pkg, acc, version) => Object.assign(acc, { [pkg]: O.getOrElse(function_1.constant(version))(O.fromNullable(hoistedPackages.get(pkg))) }))), O.toUndefined);
    return lerna_utils_1.readFile(packageJson)
        .pipe(F.chain((contents) => function_1.pipe(StringifiedJSON_1.StringifiedJSON(PackageJsonDependencies_1.PackageJsonDependencies).decode(contents), E.map(originalJson => function_1.pipe(originalJson, shades_1.mod('dependencies')(withHoistedDependencies), shades_1.mod('devDependencies')(withHoistedDependencies), shades_1.mod('optionalDependencies')(withHoistedDependencies), shades_1.mod('peerDependencies')(withHoistedDependencies), R.filter(value => value !== undefined), updatedJson => fast_deep_equal_1.default(originalJson, updatedJson)
        ? O.none
        : O.some(updatedJson))), E.map(F.resolve), E.getOrElseW(() => F.reject({ type: 'unable to parse parse package.json', err: `Could not parse JSON from '${packageJson}` })))))
        .pipe(F.chain(updates => function_1.pipe(updates, E.fromOption(() => ({ type: 'no-op' })), E.map(lerna_utils_1.trace(debug.cmd, 'Updating file', packageJson)), E.chain(updates => function_1.pipe(lerna_utils_1.prettyStringifyJson(updates, E.toError), E.mapLeft((err) => ({ type: 'unable to stringify package.json', err })))), E.map(updates => lerna_utils_1.writeFile(packageJson)(updates)
        .pipe(F.mapRej((err) => ({ type: 'unable to write package.json', err })))), E.getOrElseW(error => ts_pattern_1.match(error)
        .with({ type: 'no-op' }, () => F.resolve(undefined))
        .otherwise(() => F.reject(error))))));
};
function main() {
    function_1.pipe(decodeDocopt(CommandLineOptions, docstring, { help: true, exit: true }), E.chain(options => function_1.pipe(findup('lerna.json', { cwd: options.package, type: 'file' }), E.map(root => ({ options, root })))), E.map(({ options, root }) => hoisted_packages_1.hoistedPackages(root)
        .pipe(F.chain(updateDependencies(path.resolve(options.package, 'package.json'))))), E.getOrElseW(errors => F.reject(errors)), F.fork(error => (console.error(error), process.exit(1)))(function_1.constVoid));
}
main();
//  LocalWords:  packageJson devDependencies optionalDependencies
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=use-hoisted-version.js.map